import sqlalchemy
import sqlalchemy.orm
import json

# please assign as required

#   credentials
USER = "..."
PASSWORD = "..."
HOST = "..."
DATABASE = "..."

# names of the columns we are interested in
POST_SUBFORUM_CAT = "..."
POST_THREAD_TITLE = "..."
POST_DATE = "..."
POST_TEXT = "...."

"""
categories of the three forums we are interested in,
please subtitute the correct values in the arrray for
- Install/Boot/Login
- Applications
- Hardware
- Network/Internet
"""
INTERESTING_SUBFORUM_CATS = [0,1,2] 

class Posts:
    def __init__(self, sub_cat, thread_title, text, date):
        self.sub_cat = sub_cat
        self.thread_title = thread_title
        self.date = date
        self.text = text

    def make_dict(self):
        return {"sub_cat": self.sub_cat, "thread_title": self.thread_title, "date": self.date, "text": self.text}


metadata = sqlalchemy.MetaData()
posts_table = sqlalchemy.Table(
    "posts",
    metadata,
    sqlalchemy.Column("id", sqlalchemy.Integer, primary_key=True),
    sqlalchemy.Column(POST_THREAD_TITLE, sqlalchemy.String(100)),
    # not sure how vBulletin categorizes subforums, please change `sqlalchemy.Integer` if required
    sqlalchemy.Column(POST_SUBFORUM_CAT, sqlalchemy.Integer),
    sqlalchemy.Column(POST_DATE, sqlalchemy.Date),
    sqlalchemy.Column(POST_TEXT, sqlalchemy.String(1000)),
)

engine = sqlalchemy.create_engine(
    "mysql://%s:%s@%s/%s" % (USER, PASSWORD, HOST, DATABASE)
)
sqlalchemy.orm.mapper(Posts, posts_table)
posts = engine.query(Posts).filter(
    Posts.date.between("2017-01-01", "2020-12-07"),
    Posts.sub_cat.in_(INTERESTING_FORUMS)
)
posts_dicts = (p.make_dict() for p in posts)
posts_json = json.dumps(posts_dicts)

if __name__ == "__main__":
    with open("exported_Adrien_Attila_DataAnalysis.json", "w", encoding="utf-8") as f:
        json.dump(posts_json, f, ensure_ascii=False, indent=4)